/*
 * Created on 2019-09-10 ( Time 09:02:06 )
 * Generated by Telosys Tools Generator ( version 3.0.0 )
 */
// This Bean has a basic Primary Key (not composite) 

package ci.diaspora.star.motors.sarl.dao.entity;

import java.io.Serializable;

//import javax.validation.constraints.* ;
//import org.hibernate.validator.constraints.* ;

import java.util.Date;
import java.util.List;

import javax.persistence.*;

/**
 * Persistent class for entity stored in table "fiche_reception"
 *
 * @author Telosys Tools Generator
 *
 */

@Entity
@Table(name="fiche_reception" )
public class FicheReception implements Serializable, Cloneable {

    private static final long serialVersionUID = 1L;

    //----------------------------------------------------------------------
    // ENTITY PRIMARY KEY ( BASED ON A SINGLE FIELD )
    //----------------------------------------------------------------------
	/*
	 * 
	 */
    @Id
    @GeneratedValue(strategy=GenerationType.AUTO)
    @Column(name="id", nullable=false)
    private Integer    id           ;


    //----------------------------------------------------------------------
    // ENTITY DATA FIELDS 
    //----------------------------------------------------------------------    
	/*
	 * 
	 */
    @Column(name="couleur_vehicule_id")
    private Integer    couleurVehiculeId ;

	/*
	 * 
	 */
    @Column(name="numero_fiche", length=255)
    private String     numeroFiche  ;

	/*
	 * 
	 */
    @Column(name="interlocuteur", length=255)
    private String     interlocuteur ;

	/*
	 * 
	 */
    @Column(name="nom_deposeur", length=255)
    private String     nomDeposeur  ;

	/*
	 * 
	 */
    @Column(name="nom_recepteur", length=255)
    private String     nomRecepteur ;

	/*
	 * 
	 */
    @Column(name="kilometrage", length=255)
    private String     kilometrage  ;

	/*
	 * 
	 */
    @Column(name="autres")
    private String     autres       ;

	/*
	 * 
	 */
    @Temporal(TemporalType.TIMESTAMP)
    @Column(name="date_prochaine_revision")
    private Date       dateProchaineRevision ;

	/*
	 * 
	 */
    @Temporal(TemporalType.TIMESTAMP)
    @Column(name="date_reception")
    private Date       dateReception ;

	/*
	 * 
	 */
    @Temporal(TemporalType.TIMESTAMP)
    @Column(name="date_sortie")
    private Date       dateSortie   ;

	/*
	 * 
	 */
    @Temporal(TemporalType.TIMESTAMP)
    @Column(name="date_depot")
    private Date       dateDepot    ;

	/*
	 * 
	 */
    @Temporal(TemporalType.TIMESTAMP)
    @Column(name="date_visite_technique")
    private Date       dateVisiteTechnique ;

	/*
	 * 
	 */
    @Column(name="is_deleted")
    private Boolean    isDeleted    ;

	/*
	 * 
	 */
    @Column(name="is_deposed")
    private Boolean    isDeposed    ;

	/*
	 * 
	 */
    @Column(name="is_receved")
    private Boolean    isReceved    ;

	/*
	 * 
	 */
    @Temporal(TemporalType.TIMESTAMP)
    @Column(name="created_at")
    private Date       createdAt    ;

	/*
	 * 
	 */
    @Temporal(TemporalType.TIMESTAMP)
    @Column(name="updated_at")
    private Date       updatedAt    ;

	/*
	 * 
	 */
    @Temporal(TemporalType.TIMESTAMP)
    @Column(name="deleted_at")
    private Date       deletedAt    ;

	/*
	 * 
	 */
    @Column(name="created_by")
    private Integer    createdBy    ;

	/*
	 * 
	 */
    @Column(name="updated_by")
    private Integer    updatedBy    ;

	/*
	 * 
	 */
    @Column(name="deleted_by")
    private Integer    deletedBy    ;

	// "userId" (column "user_id") is not defined by itself because used as FK in a link 
	// "vehiculeId" (column "vehicule_id") is not defined by itself because used as FK in a link 
	// "niveauCarburantId" (column "niveau_carburant_id") is not defined by itself because used as FK in a link 
	// "etatId" (column "etat_id") is not defined by itself because used as FK in a link 


    //----------------------------------------------------------------------
    // ENTITY LINKS ( RELATIONSHIP )
    //----------------------------------------------------------------------
    @ManyToOne
    @JoinColumn(name="user_id", referencedColumnName="id")
    private User user        ;
    @ManyToOne
    @JoinColumn(name="etat_id", referencedColumnName="id")
    private Etat etat        ;
    @ManyToOne
    @JoinColumn(name="niveau_carburant_id", referencedColumnName="id")
    private NiveauCarburant niveauCarburant;
    @ManyToOne
    @JoinColumn(name="vehicule_id", referencedColumnName="id")
    private Vehicule vehicule    ;

    //----------------------------------------------------------------------
    // CONSTRUCTOR(S)
    //----------------------------------------------------------------------
    public FicheReception() {
		super();
    }
    
    //----------------------------------------------------------------------
    // GETTER & SETTER FOR THE KEY FIELD
    //----------------------------------------------------------------------
    public void setId( Integer id ) {
        this.id = id ;
    }
    public Integer getId() {
        return this.id;
    }

    //----------------------------------------------------------------------
    // GETTERS & SETTERS FOR FIELDS
    //----------------------------------------------------------------------
    //--- DATABASE MAPPING : couleur_vehicule_id ( INT ) 
    public void setCouleurVehiculeId( Integer couleurVehiculeId ) {
        this.couleurVehiculeId = couleurVehiculeId;
    }
    public Integer getCouleurVehiculeId() {
        return this.couleurVehiculeId;
    }

    //--- DATABASE MAPPING : numero_fiche ( VARCHAR ) 
    public void setNumeroFiche( String numeroFiche ) {
        this.numeroFiche = numeroFiche;
    }
    public String getNumeroFiche() {
        return this.numeroFiche;
    }

    //--- DATABASE MAPPING : interlocuteur ( VARCHAR ) 
    public void setInterlocuteur( String interlocuteur ) {
        this.interlocuteur = interlocuteur;
    }
    public String getInterlocuteur() {
        return this.interlocuteur;
    }

    //--- DATABASE MAPPING : nom_deposeur ( VARCHAR ) 
    public void setNomDeposeur( String nomDeposeur ) {
        this.nomDeposeur = nomDeposeur;
    }
    public String getNomDeposeur() {
        return this.nomDeposeur;
    }

    //--- DATABASE MAPPING : nom_recepteur ( VARCHAR ) 
    public void setNomRecepteur( String nomRecepteur ) {
        this.nomRecepteur = nomRecepteur;
    }
    public String getNomRecepteur() {
        return this.nomRecepteur;
    }

    //--- DATABASE MAPPING : kilometrage ( VARCHAR ) 
    public void setKilometrage( String kilometrage ) {
        this.kilometrage = kilometrage;
    }
    public String getKilometrage() {
        return this.kilometrage;
    }

    //--- DATABASE MAPPING : autres ( TEXT ) 
    public void setAutres( String autres ) {
        this.autres = autres;
    }
    public String getAutres() {
        return this.autres;
    }

    //--- DATABASE MAPPING : date_prochaine_revision ( DATETIME ) 
    public void setDateProchaineRevision( Date dateProchaineRevision ) {
        this.dateProchaineRevision = dateProchaineRevision;
    }
    public Date getDateProchaineRevision() {
        return this.dateProchaineRevision;
    }

    //--- DATABASE MAPPING : date_reception ( DATETIME ) 
    public void setDateReception( Date dateReception ) {
        this.dateReception = dateReception;
    }
    public Date getDateReception() {
        return this.dateReception;
    }

    //--- DATABASE MAPPING : date_sortie ( DATETIME ) 
    public void setDateSortie( Date dateSortie ) {
        this.dateSortie = dateSortie;
    }
    public Date getDateSortie() {
        return this.dateSortie;
    }

    //--- DATABASE MAPPING : date_depot ( DATETIME ) 
    public void setDateDepot( Date dateDepot ) {
        this.dateDepot = dateDepot;
    }
    public Date getDateDepot() {
        return this.dateDepot;
    }

    //--- DATABASE MAPPING : date_visite_technique ( DATETIME ) 
    public void setDateVisiteTechnique( Date dateVisiteTechnique ) {
        this.dateVisiteTechnique = dateVisiteTechnique;
    }
    public Date getDateVisiteTechnique() {
        return this.dateVisiteTechnique;
    }

    //--- DATABASE MAPPING : is_deleted ( BIT ) 
    public void setIsDeleted( Boolean isDeleted ) {
        this.isDeleted = isDeleted;
    }
    public Boolean getIsDeleted() {
        return this.isDeleted;
    }

    //--- DATABASE MAPPING : is_deposed ( BIT ) 
    public void setIsDeposed( Boolean isDeposed ) {
        this.isDeposed = isDeposed;
    }
    public Boolean getIsDeposed() {
        return this.isDeposed;
    }

    //--- DATABASE MAPPING : is_receved ( BIT ) 
    public void setIsReceved( Boolean isReceved ) {
        this.isReceved = isReceved;
    }
    public Boolean getIsReceved() {
        return this.isReceved;
    }

    //--- DATABASE MAPPING : created_at ( DATETIME ) 
    public void setCreatedAt( Date createdAt ) {
        this.createdAt = createdAt;
    }
    public Date getCreatedAt() {
        return this.createdAt;
    }

    //--- DATABASE MAPPING : updated_at ( DATETIME ) 
    public void setUpdatedAt( Date updatedAt ) {
        this.updatedAt = updatedAt;
    }
    public Date getUpdatedAt() {
        return this.updatedAt;
    }

    //--- DATABASE MAPPING : deleted_at ( DATETIME ) 
    public void setDeletedAt( Date deletedAt ) {
        this.deletedAt = deletedAt;
    }
    public Date getDeletedAt() {
        return this.deletedAt;
    }

    //--- DATABASE MAPPING : created_by ( INT ) 
    public void setCreatedBy( Integer createdBy ) {
        this.createdBy = createdBy;
    }
    public Integer getCreatedBy() {
        return this.createdBy;
    }

    //--- DATABASE MAPPING : updated_by ( INT ) 
    public void setUpdatedBy( Integer updatedBy ) {
        this.updatedBy = updatedBy;
    }
    public Integer getUpdatedBy() {
        return this.updatedBy;
    }

    //--- DATABASE MAPPING : deleted_by ( INT ) 
    public void setDeletedBy( Integer deletedBy ) {
        this.deletedBy = deletedBy;
    }
    public Integer getDeletedBy() {
        return this.deletedBy;
    }


    //----------------------------------------------------------------------
    // GETTERS & SETTERS FOR LINKS
    //----------------------------------------------------------------------

    public void setUser( User user ) {
        this.user = user;
    }
    public User getUser() {
        return this.user;
    }


    public void setEtat( Etat etat ) {
        this.etat = etat;
    }
    public Etat getEtat() {
        return this.etat;
    }


    public void setNiveauCarburant( NiveauCarburant niveauCarburant ) {
        this.niveauCarburant = niveauCarburant;
    }
    public NiveauCarburant getNiveauCarburant() {
        return this.niveauCarburant;
    }


    public void setVehicule( Vehicule vehicule ) {
        this.vehicule = vehicule;
    }
    public Vehicule getVehicule() {
        return this.vehicule;
    }


    //----------------------------------------------------------------------
    // toString METHOD
    //----------------------------------------------------------------------
    public String toString() { 
        StringBuffer sb = new StringBuffer(); 
        sb.append("["); 
        sb.append(id);
        sb.append("]:"); 
        sb.append(couleurVehiculeId);
        sb.append("|");
        sb.append(numeroFiche);
        sb.append("|");
        sb.append(interlocuteur);
        sb.append("|");
        sb.append(nomDeposeur);
        sb.append("|");
        sb.append(nomRecepteur);
        sb.append("|");
        sb.append(kilometrage);
        // attribute 'autres' not usable (type = String Long Text)
        sb.append("|");
        sb.append(dateProchaineRevision);
        sb.append("|");
        sb.append(dateReception);
        sb.append("|");
        sb.append(dateSortie);
        sb.append("|");
        sb.append(dateDepot);
        sb.append("|");
        sb.append(dateVisiteTechnique);
        sb.append("|");
        sb.append(isDeleted);
        sb.append("|");
        sb.append(isDeposed);
        sb.append("|");
        sb.append(isReceved);
        sb.append("|");
        sb.append(createdAt);
        sb.append("|");
        sb.append(updatedAt);
        sb.append("|");
        sb.append(deletedAt);
        sb.append("|");
        sb.append(createdBy);
        sb.append("|");
        sb.append(updatedBy);
        sb.append("|");
        sb.append(deletedBy);
        return sb.toString(); 
    } 

	//----------------------------------------------------------------------
    // clone METHOD
    //----------------------------------------------------------------------
	@Override
	public Object clone() throws CloneNotSupportedException {
		return super.clone();
	}
}
